<?php

class RecordLabelFixer {
    public static function run() {
        $adb = \PearDatabase::getInstance();

        set_time_limit(0);

        $sql = 'SELECT SQL_CALC_FOUND_ROWS setype, crmid FROM `vtiger_crmentity` INNER JOIN vtiger_entityname ON (vtiger_entityname.modulename = vtiger_crmentity.setype) WHERE vtiger_crmentity.label = "" AND vtiger_entityname.fieldname IS NOT NULL AND vtiger_entityname.fieldname != "" LIMIT 5000';
        $result = $adb->query($sql);

        $allRows = $adb->query('SELECT FOUND_ROWS() as num;');
        $Counter1 = $adb->query_result($allRows, 0, 'num');

        if($adb->num_rows($result) == 0) {
            echo 'No records with empty labels';
        } else {
            $counterDone = 0;
            while($row = $adb->fetchByAssoc($result)) {
                $counterDone++;
                \Vtiger_Functions::updateCRMRecordLabel($row['setype'], $row['crmid'], '');
            }

            $sql = 'SELECT COUNT(*) as num FROM `vtiger_crmentity` INNER JOIN vtiger_entityname ON (vtiger_entityname.modulename = vtiger_crmentity.setype) WHERE vtiger_crmentity.label = "" AND vtiger_entityname.fieldname IS NOT NULL AND vtiger_entityname.fieldname != ""';
            $result = $adb->query($sql);
            $Counter2 = $adb->query_result($result, 0, 'num');

            echo $counterDone.' Records processed / '.($Counter1 - $Counter2) . ' Records fixed (Todo in next executions: '.$Counter2.')';
        }
    }
}

\SwVtTools\Plugin::register('fix empty Record Labels', array('RecordLabelFixer', 'run'), array(
    'description' => 'If you had a module with an error, which clear record labels, execute this function to restore empty labels for 5000 records. The duration per execution could be up to 5 minutes. Maybe execute multiple times to repair all records.',
));